blob: 666f7bbc13ebba4d675559f785fd76f50a435f43 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
Masahiro Yamadad151e972019-01-17 09:10:04 +09006# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020011#
12# vmlinux
13# ^
14# |
Masahiro Yamadad151e972019-01-17 09:10:04 +090015# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020017# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100018# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020021# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
Masahiro Yamada3ec8a5b2020-07-02 04:29:36 +090033LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
Masahiro Yamada7d153692021-12-14 11:53:52 +090037is_enabled() {
38 grep -q "^$1=y" include/config/auto.conf
39}
40
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020041# Nice output in kbuild format
42# Will be supressed by "make -s"
43info()
44{
Masahiro Yamadac39013e2021-05-17 16:03:14 +090045 printf " %-7s %s\n" "${1}" "${2}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020046}
47
Sami Tolvanena8cccdd2020-12-11 10:46:24 -080048# Generate a linker script to ensure correct ordering of initcalls.
49gen_initcalls()
50{
51 info GEN .tmp_initcalls.lds
52
53 ${PYTHON} ${srctree}/scripts/jobserver-exec \
54 ${PERL} ${srctree}/scripts/generate_initcall_order.pl \
55 ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \
56 > .tmp_initcalls.lds
57}
58
Sami Tolvanen38e89182020-12-11 10:46:20 -080059# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
60# .tmp_symversions.lds
61gen_symversions()
62{
63 info GEN .tmp_symversions.lds
64 rm -f .tmp_symversions.lds
65
66 for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
67 if [ -f ${o}.symversions ]; then
68 cat ${o}.symversions >> .tmp_symversions.lds
69 fi
70 done
71}
72
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020073# Link of vmlinux.o used for section mismatch analysis
74# ${1} output file
75modpost_link()
76{
Stephen Rothwella5967db2016-08-24 22:29:19 +100077 local objects
Sami Tolvanen38e89182020-12-11 10:46:20 -080078 local lds=""
Stephen Rothwella5967db2016-08-24 22:29:19 +100079
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100080 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090081 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100082 --no-whole-archive \
83 --start-group \
84 ${KBUILD_VMLINUX_LIBS} \
85 --end-group"
86
Masahiro Yamada7d153692021-12-14 11:53:52 +090087 if is_enabled CONFIG_LTO_CLANG; then
Sami Tolvanena8cccdd2020-12-11 10:46:24 -080088 gen_initcalls
89 lds="-T .tmp_initcalls.lds"
90
Masahiro Yamada7d153692021-12-14 11:53:52 +090091 if is_enabled CONFIG_MODVERSIONS; then
Sami Tolvanen38e89182020-12-11 10:46:20 -080092 gen_symversions
93 lds="${lds} -T .tmp_symversions.lds"
94 fi
95
Sami Tolvanendc5723b2020-12-11 10:46:19 -080096 # This might take a while, so indicate that we're doing
97 # an LTO link
98 info LTO ${1}
99 else
100 info LD ${1}
101 fi
102
Sami Tolvanen38e89182020-12-11 10:46:20 -0800103 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200104}
105
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100106objtool_link()
107{
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700108 local objtoolcmd;
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100109 local objtoolopt;
110
Masahiro Yamada7d153692021-12-14 11:53:52 +0900111 if is_enabled CONFIG_LTO_CLANG && is_enabled CONFIG_STACK_VALIDATION; then
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700112 # Don't perform vmlinux validation unless explicitly requested,
113 # but run objtool on vmlinux.o now that we have an object file.
Masahiro Yamada7d153692021-12-14 11:53:52 +0900114 if is_enabled CONFIG_UNWINDER_ORC; then
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700115 objtoolcmd="orc generate"
116 fi
117
118 objtoolopt="${objtoolopt} --duplicate"
119
Masahiro Yamada7d153692021-12-14 11:53:52 +0900120 if is_enabled CONFIG_FTRACE_MCOUNT_USE_OBJTOOL; then
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700121 objtoolopt="${objtoolopt} --mcount"
122 fi
123 fi
124
Masahiro Yamada7d153692021-12-14 11:53:52 +0900125 if is_enabled CONFIG_VMLINUX_VALIDATION; then
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700126 objtoolopt="${objtoolopt} --noinstr"
127 fi
128
129 if [ -n "${objtoolopt}" ]; then
130 if [ -z "${objtoolcmd}" ]; then
131 objtoolcmd="check"
132 fi
133 objtoolopt="${objtoolopt} --vmlinux"
Masahiro Yamada7d153692021-12-14 11:53:52 +0900134 if ! is_enabled CONFIG_FRAME_POINTER; then
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100135 objtoolopt="${objtoolopt} --no-fp"
136 fi
Masahiro Yamada7d153692021-12-14 11:53:52 +0900137 if is_enabled CONFIG_GCOV_KERNEL || is_enabled CONFIG_LTO_CLANG; then
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100138 objtoolopt="${objtoolopt} --no-unreachable"
139 fi
Masahiro Yamada7d153692021-12-14 11:53:52 +0900140 if is_enabled CONFIG_RETPOLINE; then
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100141 objtoolopt="${objtoolopt} --retpoline"
142 fi
Masahiro Yamada7d153692021-12-14 11:53:52 +0900143 if is_enabled CONFIG_X86_SMAP; then
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100144 objtoolopt="${objtoolopt} --uaccess"
145 fi
Linus Torvaldsfd6f57b2022-01-19 11:15:19 +0200146 if is_enabled CONFIG_SLS; then
Peter Zijlstrae463a092021-12-04 14:43:44 +0100147 objtoolopt="${objtoolopt} --sls"
148 fi
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100149 info OBJTOOL ${1}
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700150 tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100151 fi
152}
153
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200154# Link of vmlinux
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700155# ${1} - output file
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700156# ${2}, ${3}, ... - optional extra .o files
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200157vmlinux_link()
158{
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700159 local output=${1}
Masahiro Yamada8f130512021-08-19 09:57:37 +0900160 local objs
161 local libs
Masahiro Yamada5df77ad2021-08-19 09:57:39 +0900162 local ld
163 local ldflags
164 local ldlibs
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200165
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700166 info LD ${output}
167
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700168 # skip output file argument
169 shift
170
Masahiro Yamada7d153692021-12-14 11:53:52 +0900171 if is_enabled CONFIG_LTO_CLANG; then
Masahiro Yamada8f130512021-08-19 09:57:37 +0900172 # Use vmlinux.o instead of performing the slow LTO link again.
173 objs=vmlinux.o
174 libs=
175 else
176 objs="${KBUILD_VMLINUX_OBJS}"
177 libs="${KBUILD_VMLINUX_LIBS}"
178 fi
179
Masahiro Yamada5df77ad2021-08-19 09:57:39 +0900180 if [ "${SRCARCH}" = "um" ]; then
181 wl=-Wl,
182 ld="${CC}"
183 ldflags="${CFLAGS_vmlinux}"
184 ldlibs="-lutil -lrt -lpthread"
185 else
186 wl=
187 ld="${LD}"
188 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
189 ldlibs=
190 fi
191
192 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
193
Kees Cookaf73d782020-03-03 18:18:34 -0800194 # The kallsyms linking does not need debug symbols included.
195 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
Masahiro Yamada5df77ad2021-08-19 09:57:39 +0900196 ldflags="${ldflags} ${wl}--strip-debug"
Kees Cookaf73d782020-03-03 18:18:34 -0800197 fi
198
Masahiro Yamada7d153692021-12-14 11:53:52 +0900199 if is_enabled CONFIG_VMLINUX_MAP; then
Masahiro Yamada5df77ad2021-08-19 09:57:39 +0900200 ldflags="${ldflags} ${wl}-Map=${output}.map"
Rasmus Villemoes5cc12472021-03-05 10:27:07 +0100201 fi
202
Masahiro Yamada5df77ad2021-08-19 09:57:39 +0900203 ${ld} ${ldflags} -o ${output} \
204 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
205 ${wl}--start-group ${libs} ${wl}--end-group \
206 $@ ${ldlibs}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200207}
208
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700209# generate .BTF typeinfo from DWARF debuginfo
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700210# ${1} - vmlinux image
211# ${2} - file to dump raw BTF data into
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700212gen_btf()
213{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700214 local pahole_ver
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700215
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700216 if ! [ -x "$(command -v ${PAHOLE})" ]; then
Chris Down2a67a6c2020-01-22 00:01:10 +0000217 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700218 return 1
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700219 fi
220
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700221 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
Lorenz Bauer21a85bd2020-06-08 10:42:57 +0100222 if [ "${pahole_ver}" -lt "116" ]; then
223 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700224 return 1
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700225 fi
226
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700227 vmlinux_link ${1}
Kees Cookaf73d782020-03-03 18:18:34 -0800228
229 info "BTF" ${2}
Jiri Olsa9741e072021-10-29 14:57:29 +0200230 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700231
Fangrui Song90ceddc2020-03-18 15:27:46 -0700232 # Create ${2} which contains just .BTF section but no symbols. Add
233 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
234 # deletes all symbols including __start_BTF and __stop_BTF, which will
235 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
236 # objcopy warnings: "empty loadable segment detected at ..."
237 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
238 --strip-all ${1} ${2} 2>/dev/null
239 # Change e_type to ET_REL so that it can be used to link final vmlinux.
240 # Unlike GNU ld, lld does not allow an ET_EXEC input.
241 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700242}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200243
Masahiro Yamada08beb662020-09-25 00:45:46 +0900244# Create ${2} .S file with all symbols from the ${1} object file
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200245kallsyms()
246{
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200247 local kallsymopt;
248
Masahiro Yamada7d153692021-12-14 11:53:52 +0900249 if is_enabled CONFIG_KALLSYMS_ALL; then
James Hogan6895f972012-09-06 22:11:25 +0100250 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200251 fi
252
Masahiro Yamada7d153692021-12-14 11:53:52 +0900253 if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030254 kallsymopt="${kallsymopt} --absolute-percpu"
255 fi
256
Masahiro Yamada7d153692021-12-14 11:53:52 +0900257 if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700258 kallsymopt="${kallsymopt} --base-relative"
259 fi
260
Masahiro Yamada08beb662020-09-25 00:45:46 +0900261 info KSYMS ${2}
262 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200263}
264
Kees Cook8959e392019-08-13 08:15:32 -0700265# Perform one step in kallsyms generation, including temporary linking of
266# vmlinux.
267kallsyms_step()
268{
269 kallsymso_prev=${kallsymso}
Kees Cookaf73d782020-03-03 18:18:34 -0800270 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
271 kallsymso=${kallsyms_vmlinux}.o
Masahiro Yamada08beb662020-09-25 00:45:46 +0900272 kallsyms_S=${kallsyms_vmlinux}.S
Kees Cook8959e392019-08-13 08:15:32 -0700273
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700274 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
Masahiro Yamada08beb662020-09-25 00:45:46 +0900275 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
276
277 info AS ${kallsyms_S}
278 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
279 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
280 -c -o ${kallsymso} ${kallsyms_S}
Kees Cook8959e392019-08-13 08:15:32 -0700281}
282
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200283# Create map file with all symbols from ${1}
284# See mksymap for additional details
285mksysmap()
286{
287 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
288}
289
Shile Zhang10916702019-12-04 08:46:31 +0800290sorttable()
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700291{
Shile Zhang10916702019-12-04 08:46:31 +0800292 ${objtree}/scripts/sorttable ${1}
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700293}
294
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200295# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200296cleanup()
297{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700298 rm -f .btf.*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200299 rm -f .tmp_System.map
Sami Tolvanena8cccdd2020-12-11 10:46:24 -0800300 rm -f .tmp_initcalls.lds
Sami Tolvanen38e89182020-12-11 10:46:20 -0800301 rm -f .tmp_symversions.lds
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200302 rm -f .tmp_vmlinux*
303 rm -f System.map
304 rm -f vmlinux
Rasmus Villemoes5cc12472021-03-05 10:27:07 +0100305 rm -f vmlinux.map
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200306 rm -f vmlinux.o
Rasmus Villemoes0b956e22021-03-05 11:02:12 +0100307 rm -f .vmlinux.d
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200308}
309
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200310# Use "make V=1" to debug this script
311case "${KBUILD_VERBOSE}" in
312*1*)
313 set -x
314 ;;
315esac
316
317if [ "$1" = "clean" ]; then
318 cleanup
319 exit 0
320fi
321
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200322# Update version
323info GEN .version
Masahiro Yamada278ae602017-09-22 14:31:13 +0900324if [ -r .version ]; then
325 VERSION=$(expr 0$(cat .version) + 1)
326 echo $VERSION > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200327else
Masahiro Yamada278ae602017-09-22 14:31:13 +0900328 rm -f .version
329 echo 1 > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200330fi;
331
332# final build of init/
Masahiro Yamada083bc0e2020-02-11 05:06:34 +0900333${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200334
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100335#link vmlinux.o
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100336modpost_link vmlinux.o
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100337objtool_link vmlinux.o
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100338
339# modpost vmlinux.o to check for section mismatches
Masahiro Yamadaa7215882019-07-31 00:59:02 +0900340${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100341
Alexey Gladkov898490c2019-04-29 18:11:14 +0200342info MODINFO modules.builtin.modinfo
343${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
Masahiro Yamada8b41fc42019-12-19 17:33:29 +0900344info GEN modules.builtin
345# The second line aids cases where multiple modules share the same object.
346tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
347 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
Alexey Gladkov898490c2019-04-29 18:11:14 +0200348
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700349btf_vmlinux_bin_o=""
Masahiro Yamada7d153692021-12-14 11:53:52 +0900350if is_enabled CONFIG_DEBUG_INFO_BTF; then
Kees Cookaf73d782020-03-03 18:18:34 -0800351 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
352 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
Stanislav Fomichevda5fb182019-11-27 08:14:10 -0800353 echo >&2 "Failed to generate BTF for vmlinux"
354 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
355 exit 1
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700356 fi
357fi
358
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200359kallsymso=""
Kees Cook8959e392019-08-13 08:15:32 -0700360kallsymso_prev=""
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200361kallsyms_vmlinux=""
Masahiro Yamada7d153692021-12-14 11:53:52 +0900362if is_enabled CONFIG_KALLSYMS; then
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200363
364 # kallsyms support
365 # Generate section listing all symbols and add it into vmlinux
366 # It's a three step process:
Hui Su2216cf62021-10-08 19:24:38 +0800367 # 1) Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200368 # but __kallsyms is empty.
369 # Running kallsyms on that gives us .tmp_kallsyms1.o with
370 # the right size
Hui Su2216cf62021-10-08 19:24:38 +0800371 # 2) Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200372 # the right size, but due to the added section, some
373 # addresses have shifted.
Hui Su2216cf62021-10-08 19:24:38 +0800374 # From here, we generate a correct .tmp_vmlinux.kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100375 # 3) That link may have expanded the kernel image enough that
376 # more linker branch stubs / trampolines had to be added, which
377 # introduces new names, which further expands kallsyms. Do another
378 # pass if that is the case. In theory it's possible this results
379 # in even more stubs, but unlikely.
380 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
381 # other bugs.
382 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200383 #
384 # a) Verify that the System.map from vmlinux matches the map from
385 # ${kallsymso}.
386
Kees Cook8959e392019-08-13 08:15:32 -0700387 kallsyms_step 1
388 kallsyms_step 2
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200389
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100390 # step 3
Kees Cook8959e392019-08-13 08:15:32 -0700391 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
392 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100393
394 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Kees Cook8959e392019-08-13 08:15:32 -0700395 kallsyms_step 3
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200396 fi
397fi
398
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700399vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700400
Jiri Olsac9a0f3b2020-07-11 23:53:24 +0200401# fill in BTF IDs
Masahiro Yamada7d153692021-12-14 11:53:52 +0900402if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
Jiri Olsa017dab32020-09-23 20:57:34 +0200403 info BTFIDS vmlinux
404 ${RESOLVE_BTFIDS} vmlinux
Jiri Olsac9a0f3b2020-07-11 23:53:24 +0200405fi
406
Yinan Liu72b39422021-12-12 19:33:58 +0800407info SYSMAP System.map
408mksysmap vmlinux System.map
409
Masahiro Yamada7d153692021-12-14 11:53:52 +0900410if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
Shile Zhang10916702019-12-04 08:46:31 +0800411 info SORTTAB vmlinux
Shile Zhangf14bf6a2019-12-04 08:46:33 +0800412 if ! sorttable vmlinux; then
413 echo >&2 Failed to sort kernel tables
414 exit 1
415 fi
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700416fi
417
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200418# step a (see comment above)
Masahiro Yamada7d153692021-12-14 11:53:52 +0900419if is_enabled CONFIG_KALLSYMS; then
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200420 mksysmap ${kallsyms_vmlinux} .tmp_System.map
421
422 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200423 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200424 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200425 exit 1
426 fi
427fi
Rasmus Villemoes0b956e22021-03-05 11:02:12 +0100428
429# For fixdep
430echo "vmlinux: $0" > .vmlinux.d